import { Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';

import { ReplayController } from './replay.controller';
import { ReplayService } from './replay.service';
import {
  GameEntity,
  Game_PersonEntity,
  ObjectivePointEntity,
  ObjectivePoint_HistoryEntity,
} from '../game/game.entity';
import { FactionEntity, GameGroupEntity } from '../faction/faction.entity';
import { UserService } from '../user/user.service';
import { FactionService } from '../faction/faction.service';
import { TrackingService } from '../tracking/tracking.service';
import { TrackingEntity } from '../tracking/tracking.entity';
import { PersonEntity } from '../user/user.entity';
import {
  MapDrawingEntity,
  MapDrawingHistoryEntity,
} from '../draw/coordinate.entity';
import { ScoreService } from '../score/score.service';
import { ScoreEntity } from '../score/score.entity';
import { NotificationModule } from '../notifications/notifications.module';
import { GameService } from '../game/game.service';

/////////////////////////////////////////////////////////////////////
/// Replay                                                        ///
/// - contains everything to do with Replay data.                 ///
/////////////////////////////////////////////////////////////////////

@Module({
  imports: [
    TypeOrmModule.forFeature([
      PersonEntity,
      GameEntity,
      FactionEntity,
      TrackingEntity,
      GameGroupEntity,
      Game_PersonEntity,
      MapDrawingEntity,
      MapDrawingHistoryEntity,
      ScoreEntity,
      ObjectivePointEntity,
      ObjectivePoint_HistoryEntity,
    ]),
    NotificationModule,
  ],
  controllers: [ReplayController],
  providers: [
    ReplayService,
    UserService,
    FactionService,
    TrackingService,
    ScoreService,
    GameService,
  ],
})
export class ReplayModule {}
